#ifdef WIN32
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <SDL.h>
#include <string.h>
#include <time.h>

int RX;   //rozmer obrazovky x
int RY;   //rozmer obrazovky y
#define BPP 32  //hloubka barev (nemenit)
#define MAXIMUM_R 1.2 
#define MAXIMUM_X2 1.2

SDL_Surface * screen;

double r=1;             //polomer kruhu drahy
double rstep=-0.001;    //rychlost drahy
double t=0;             //parametr drahy
double R = 1;           //polomer kruhu, po kterem se pohybuje roh zobrazovane oblasti komlex. roviny
double fi = 9;          //uhel poc. zobr.
double X2=1.8;          //strana ctverce, ktery se zobrazi
double X2MIN = MAXIMUM_X2/2;
double X2MAX = MAXIMUM_X2;
double RMAX = MAXIMUM_R;
double RMIN = MAXIMUM_R/2;
double Rstep = 0.001+double(rand()%100)/10000;
double fistep = 0.001+double(rand()%100)/10000;
double x2step = 0.05;
double tstep=0.01;
#define rmax 2
#define rmin 0.4

/////////////////////////////////////////////////////
//
//		POMOCNE FCE
//
/////////////////////////////////////////////////////
void Slock(SDL_Surface *screen)
{
  if ( SDL_MUSTLOCK(screen) ) {
    if ( SDL_LockSurface(screen) < 0 ) {
      return;
    }
  }
}

void Sulock(SDL_Surface *screen)
{
  if ( SDL_MUSTLOCK(screen) ) {
    SDL_UnlockSurface(screen);
  }
}

/////////////////////////////////////////
// nakresli pixel
void DrawPixel(SDL_Surface *screen, int x, int y, Uint8 R, Uint8 G, Uint8 B)
{
  Uint32 color = SDL_MapRGB(screen->format, R, G, B);
  switch (screen->format->BytesPerPixel) {
    case 1: // Assuming 8-bpp
      {
        Uint8 *bufp;
        bufp = (Uint8 *)screen->pixels + y*screen->pitch + x;
        *bufp = color;
      }
      break;
    case 2: // Probably 15-bpp or 16-bpp
      {
        Uint16 *bufp;
        bufp = (Uint16 *)screen->pixels + y*screen->pitch/2 + x;
        *bufp = color;
      }
      break;
    case 3: // Slow 24-bpp mode, usually not used
      {
        Uint8 *bufp;
        bufp = (Uint8 *)screen->pixels + y*screen->pitch + x * 3;
        if(SDL_BYTEORDER == SDL_LIL_ENDIAN) {
          bufp[0] = color;
          bufp[1] = color >> 8;
          bufp[2] = color >> 16;
        } else {
          bufp[2] = color;
          bufp[1] = color >> 8;
          bufp[0] = color >> 16;
        }
      }
      break;
    case 4: // Probably 32-bpp
      {
        Uint32 *bufp;
        bufp = (Uint32 *)screen->pixels + y*screen->pitch/4 + x;
        *bufp = color;
      }
      break;
  }
}

//spocte a zobrazi mandelbrotovu mnozinu
void Mandel(double x1,double y1, double x2, double y2,int iter,SDL_Surface * s)
{
  int nx,ny;       //position in bitmap
  double dx,dy,p,q;
  int k;
  double xx2,xx1;
  double yy2,yy1;

  double r,max_r;
  double x1_orig=x1;

  dx = (x2 - x1)/s->w;
  dy = (y2 - y1)/s->h;

  Uint32 *bufp;
  bufp = (Uint32 *)s->pixels;
  for(ny=0;ny<s->h;ny++)
  {
    x1=x1_orig;
    for(nx=0;nx<s->w;nx++)
    {
      k=0;
     
      p =x1;
      q =y1;

      r=p*p+q*q;
      if (r>4) max_r=r;
      else   max_r=4;

      xx1=x1;
      yy1=y1;

      while ((r<=max_r) && (k<iter))
      {
        xx2 = xx1*xx1-yy1*yy1+p;
        yy2 = 2*xx1*yy1+q;

        xx1=xx2;
        yy1=yy2;

        k++;

        r = xx1*xx1+yy1*yy1;
      }
      if (k==iter) k=0;
      *bufp = k;
      bufp++;
      x1 = x1+dx;
    }
    bufp = (Uint32*) s->pixels+ny*s->pitch/4;
    y1=y1+dy;
  }
}

void Julia(double x1,double y1, double x2, double y2,int iter,double p,double q,SDL_Surface * s)
{
  int nx,ny;       //position in bitmap
  double dx,dy;
  Uint32 k;
  double xx2,xx1;
  double yy2,yy1;

  double r,max_r;
  double x1_orig=x1;
  double y1_orig=y1;

  dx = (x2 - x1)/s->w;
  dy = (y2 - y1)/s->h;

  Uint32 *bufp;
  bufp = (Uint32 *)s->pixels;
  for(ny=0;ny<s->h;ny++)
  {
    x1=x1_orig;
    for(nx=0;nx<s->w;nx++)
    {
      k=0;
     
      r=p*p+q*q;
      if (r>4) max_r=r;
      else   max_r=4;

      xx1=x1;
      yy1=y1;


      while ((r<=max_r) && (k<iter))
      {
        xx2 = xx1*xx1-yy1*yy1+p;
        yy2 = 2*xx1*yy1+q;

        xx1=xx2;
        yy1=yy2;

        k++;

        r = xx1*xx1+yy1*yy1;
      }
      
      *bufp = k<<18 | k<<10 | k<<2;
     
      bufp++;
      x1 = x1+dx;
    }
    y1=y1+dy;
    bufp = (Uint32*) s->pixels+ny*s->pitch/4;
  }
}


void DrawScene(SDL_Surface *screen)
{
  Slock(screen);
  Julia(R*cos(fi),R*sin(fi),R*cos(fi)+X2,R*sin(fi)+X2,63,r*cos(t)-0.3,r*sin(t),screen);
  Sulock(screen);
  SDL_Flip(screen);

  r=r+rstep;
  t=t+tstep;

  R+=Rstep;
  fi+=fistep;

  X2+=x2step;

  if (R>RMAX && Rstep>0) 
  {
    R=RMAX;
    RMAX = RMIN+(MAXIMUM_R-RMIN)*double(rand()%1000)/1000;
    Rstep = -double(rand()%100)/10000;
  }

  if (R<RMIN && Rstep<0) 
  {
    R=RMIN;
    RMIN = RMAX*double(rand()%1000)/1000;
    Rstep = double(rand()%100)/10000;
  }

  if (X2<X2MIN)
  {
    x2step=0.0001+double(rand()%100)/10000;
    X2MIN = X2MAX*double(rand()%1000)/1000;
  }

  if (X2>2)
  {
    x2step=-0.0001-double(rand()%100)/10000;
    X2MAX = X2MIN+(MAXIMUM_X2-X2MIN)*double(rand()%1000)/1000;
  }
  
  if (r<rmin || r>rmax) rstep=-rstep;
  if (t<0 || t>100) tstep=-tstep;
  if (fi<0 || fi>100) fistep=-fistep;
}

int main(int argc, char *argv[])
{

  /* Initialize the SDL library */
  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    printf("Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  printf("SDL initialized.\n");
  /* Clean up on exit */
  atexit(SDL_Quit);

  printf("Zvolte rozliseni:\n");
  printf("1 - 320x240x32\n");
  printf("2 - 400x300x32\n");
  printf("3 - 512x384x32\n");
  printf("4 - 640x480x32\n");
  printf("5 - 800x600x32\n");
  printf("6 - 1024x768x32\n>");

  int res=1;
  scanf("%d",&res);
  switch (res)
  {
  case 1:
    RX=320;
    RY=240;
    break;
  case 2:
    RX=400;
    RY=300;
    break;
  case 3:
    RX=512;
    RY=384;
    break;
  case 4:
    RX=640;
    RY=480;
    break;
  case 5:
    RX=800;
    RY=600;
    break;
  case 6:
    RX=1024;
    RY=768;
    break;
  }

  srand( (unsigned)time( NULL ) );


  /*
   * Initialize the display in a 32-bit hardware supported mode
   */

  screen=SDL_SetVideoMode(RX,RY,BPP,SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
  if ( screen == NULL ) {
    printf("Unable to set video: %s\n", SDL_GetError());
    exit(1);
  }
  printf("Set at %d bits-per-pixel mode\n", screen->format->BitsPerPixel);
  printf("Press Esc to quit\n");
  int done=0;

  /* Loop until an SDL_QUIT event is found or until we press Esc */
  while(done == 0) {
    SDL_Event event;

    /* Poll for events */
    while ( SDL_PollEvent(&event) )
    {
      if ( event.type == SDL_QUIT )  {  done = 1;  }
      if ( event.type == SDL_KEYDOWN ) 
	  {
        if ( event.key.keysym.sym == SDLK_ESCAPE ) { done = 1; }
      }
    }
    DrawScene(screen);		//kreslime
  }

  return 0;
}
